/*
 * Copyright (c) 2012, Noel Lemouel
 * All rights reserved.
 */

#include <stdio.h>

#ifdef MACOSX
#include "SDL/include/SDL.h"
#else
#include "SDL.h"
#endif

extern SDL_Surface *fb;

static unsigned int v_tile_data_active = 0;
static unsigned int v_bg_map_active = 0;

/* forwards */
void ui_tile_data(SDL_Event *event);
void ui_bg_map(SDL_Event *event);

void ui(void)
{
	v_tile_data_active = 1;
	v_tile_data_init_16((Uint16*)fb->pixels);

	while(1)
	{

		usleep(100000);

		/* Poll for events, and handle the ones we care about. */
		SDL_Event event;
		while (SDL_PollEvent(&event))
		{
			switch (event.type)
			{
				case SDL_KEYDOWN:
					break;
				case SDL_KEYUP:
					if (event.key.keysym.sym == SDLK_ESCAPE){
						return;
					}else if(event.key.keysym.sym == ' '){
						if(v_tile_data_active)
						{
							v_tile_data_active = 0;
							v_bg_map_active = 1;
							v_bg_map_9800h_init_16((Uint16*)fb->pixels);
						}else{
							v_tile_data_active = 1;
							v_bg_map_active = 0;
							v_tile_data_init_16((Uint16*)fb->pixels);							
						}
					}else{
						if(v_tile_data_active) ui_tile_data(&event);
						if(v_bg_map_active) ui_bg_map(&event);
					}

					break;
				case SDL_QUIT:
					return;
			}
		}
	}

}

void ui_tile_data(SDL_Event *event)
{

	if (event->key.keysym.sym == SDLK_UP){
		// printf("up\n");
		v_tile_data_move_cursor_up_16((Uint16*)fb->pixels);
	}
	if (event->key.keysym.sym == SDLK_DOWN){
		// printf("down\n");
		v_tile_data_move_cursor_down_16((Uint16*)fb->pixels);
	}
	if (event->key.keysym.sym == SDLK_LEFT){
		// printf("left\n");
		v_tile_data_move_cursor_left_16((Uint16*)fb->pixels);
	}
	if (event->key.keysym.sym == SDLK_RIGHT){
		// printf("right\n");
		v_tile_data_move_cursor_right_16((Uint16*)fb->pixels);
	}

}

void ui_bg_map(SDL_Event *event)
{

}

