/*
 * Copyright (c) 2011, Noel Lemouel
 * All rights reserved.
 */

#include <stdio.h>
#include "ui.h"

static int t_num = 0;

void v_tile_data_init_16(unsigned short* fb)
{

	unsigned int i, j, k;

	/* clear framebuffer */

	for(i=0; i<SCX*SCY; i++)
	{
		fb[i] = 0x0000;
	}

	k=0;
	for(i=0; i<24; i++)
	{
		for(j=0; j<16; j++)
		{
// #ifdef UI_RGB32
//			blit_tile_32(k++, &((Uint16*)fb->pixels)[(TILE_MAP_Y*SCX)+TILE_MAP_X], (i*8), (j*8));
// #endif

// #ifdef UI_RGB16
			blit_tile_16(k++, &(fb)[(TILE_MAP_Y*SCX)+TILE_MAP_X], (j*8), (i*8));
// #endif
		}
	}

	v_tile_data_update_cursor_16(fb, t_num, t_num);

	draw_line_16(fb, 0, 47, 480, 47);
	draw_line_16(fb, 23, 0, 23, 272);

	blit_tile_8x_16(t_num, fb, TILE_X8_X, TILE_X8_Y);
//	draw_line_16(fb, 351, 0, 351, 272);

	fb_update();
}

int v_tile_data_update_cursor_16(unsigned short* fb, unsigned int t_num_0, unsigned int t_num_1)
{
	unsigned int t_x;
	unsigned int t_y;

   if(t_num > 384)
   {
      return -1;
   }

	if(t_num_0 > 15)
	{
		t_x = TILE_MAP_X + ( ((t_num_0 - ((t_num_0 / 16) * 16))) * 8 );
		t_y = TILE_MAP_Y + ((t_num_0 / 16) * 8);
	}else{
		t_x = TILE_MAP_X + (t_num_0 * 8);
		t_y = TILE_MAP_Y;
	}

	blit_tile_16(t_num_0, fb, t_x, t_y);

	if(t_num_1 > 15)
	{
		t_x = TILE_MAP_X + ( ((t_num_1 - ((t_num_1 / 16) * 16))) * 8 );
		t_y = TILE_MAP_Y + ((t_num_1 / 16) * 8);
	}else{
		t_x = TILE_MAP_X + (t_num_1 * 8);
		t_y = TILE_MAP_Y;
	}

	draw_cursor_8x8_16(fb, t_x, t_y);

//	fb_update();

	return 0;
}

int v_tile_data_move_cursor_up_16(unsigned short* fb)
{
	unsigned int t_0 = t_num;

	t_num-=16;

	if(t_num < 0)
	{
		t_num += 384;

		v_tile_data_update_cursor_16(fb, t_0, t_num);
		blit_tile_8x_16(t_num, fb, TILE_X8_X, TILE_X8_Y);

		fb_update();

		return 0;
	}

	v_tile_data_update_cursor_16(fb, t_0, t_num);
	blit_tile_8x_16(t_num, fb, TILE_X8_X, TILE_X8_Y);

	fb_update();

	return 0;
}

int v_tile_data_move_cursor_down_16(unsigned short* fb)
{
	unsigned int t_0 = t_num;

	t_num+=16;

	if(t_num > 383)
	{
		t_num -= 384;

		v_tile_data_update_cursor_16(fb, t_0, t_num);
		blit_tile_8x_16(t_num, fb, TILE_X8_X, TILE_X8_Y);

		fb_update();

		return 0;
	}

	v_tile_data_update_cursor_16(fb, t_0, t_num);
	blit_tile_8x_16(t_num, fb, TILE_X8_X, TILE_X8_Y);

	fb_update();

	return 0;
}

int v_tile_data_move_cursor_left_16(unsigned short* fb)
{
	unsigned int t_0 = t_num;

	t_num--;

	if(t_num == -1)
	{
		t_num = 383;

		v_tile_data_update_cursor_16(fb, t_0, t_num);
		blit_tile_8x_16(t_num, fb, TILE_X8_X, TILE_X8_Y);

		fb_update();

		return 0;
	}

	v_tile_data_update_cursor_16(fb, t_0, t_num);
	blit_tile_8x_16(t_num, fb, TILE_X8_X, TILE_X8_Y);

	fb_update();

	return 0;
}

int v_tile_data_move_cursor_right_16(unsigned short* fb)
{
	unsigned int t_0 = t_num;

	t_num++;

	if(t_num == 384)
	{
		t_num = 0;

		v_tile_data_update_cursor_16(fb, t_0, t_num);
	   blit_tile_8x_16(t_num, fb, TILE_X8_X, TILE_X8_Y);

		fb_update();

		return 0;
	}

	v_tile_data_update_cursor_16(fb, t_0, t_num);
	blit_tile_8x_16(t_num, fb, TILE_X8_X, TILE_X8_Y);

	fb_update();

	return 0;
}

